##################################################################################
#
#   Kaivo Public Software License
#
#   Copyright (c) 2001, Kaivo, Inc.
#   All rights reserved.
#
#   Redistribution and use in source and binary forms, with or without
#   modification, are permitted provided that the following conditions are
#   met:
#
#       o Redistributions of source code must retain the above copyright
#         notice, this list of conditions and the following disclaimer.
#
#       o Redistributions in binary form must reproduce the above copyright
#         notice, this list of conditions and the following disclaimer
#         in the documentation and/or other materials provided with the
#         distribution.
#
#       o Neither Kaivo nor the names of its contributors may be used to
#         endorse or promote products derived from this software without 
#         specific prior written permission.
#
#   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
#   AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
#   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
#   ARE DISCLAIMED. IN NO EVENT SHALL KAIVO OR ITS CONTRIBUTORS BE LIABLE FOR 
#   ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
#   DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
#   SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER 
#   CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
#   OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE 
#   USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
##################################################################################

"""CatalogAware Property Extension"""

from OFS.PropertyManager import PropertyManager

#
# Define event handlers for catalog awareness
#

def reindex_object_or_pass (self):
    try:
	self.reindex_object()
    except:
	pass


original_addProperty = PropertyManager.manage_addProperty

def manage_addProperty(self, id, value, type, REQUEST=None):
    """Add property and reindex"""
    r = original_addProperty(self,id,value,type,REQUEST)
    reindex_object_or_pass (self)
    return r

PropertyManager.manage_addProperty = manage_addProperty


original_delProperties = PropertyManager.manage_delProperties

def manage_delProperties(self, ids=None, REQUEST=None):
    """Delete properties and reindex"""
    r = original_delProperties(self, ids, REQUEST)
    reindex_object_or_pass (self)
    return r

PropertyManager.manage_delProperties = manage_delProperties


original_changeProperties = PropertyManager.manage_changeProperties

def manage_changeProperties(self, REQUEST=None, **kw):
    """Update properties and reindex"""
    r = original_changeProperties(self, REQUEST, **kw)
    reindex_object_or_pass (self)
    return r

PropertyManager.manage_changeProperties = manage_changeProperties


original_editProperties = PropertyManager.manage_editProperties

def manage_editProperties(self, REQUEST):
    """Edit Properties and reindex"""
    r = original_editProperties(self, REQUEST)
    reindex_object_or_pass (self)
    return r

PropertyManager.manage_editProperties = manage_editProperties

from zLOG import LOG, INFO
LOG('CatalogAwareProperties', INFO, 'Applied patch version 0.1.1')

